package attrInfo;
import WebFlow.*;
import WebFlow.event.*;
import org.omg.CORBA.*;
import java.io.*;
import java.util.*;
import org.omg.CORBA.InterfaceDefPackage.*;
import org.omg.CORBA.ContainedPackage.*;
   
public class irtraverse{
   static ORB orb ;
   static Hashtable interfacedef;
   static  org.omg.CORBA.Repository repository ;


   public static void main(String args[])
    {
      org.omg.CORBA.Object IRobj=null;
      String idlFile = args[0];
      String IRstr   ; //= args[1];
      System.out.println("I am looking for idl file:"+idlFile);
      orb = ORB.init(args, new java.util.Properties());
      BOA boa = orb.BOA_init(args, new java.util.Properties());
      interfacedef = new Hashtable();

     
      IRobj = startIntRep();
      repository = org.omg.CORBA.RepositoryHelper.narrow(IRobj);
     
      //first irfeed the idlFile
      IRstr = orb.object_to_string(IRobj);
      if (IRstr == null){
	System.out.println("I am returning because IT is null");
	return;
      }

      //wait until IR is up
      waitUntil(IRstr);
      
      
      String command = "irfeed -ORBrepository "+ IRstr+" "+idlFile;
      try{
	System.out.println("configReader :irfeeding the file:"+idlFile);
	Process p = Runtime.getRuntime().exec(command);

	p.waitFor();
      }catch (Exception ex){
	System.out.println("Error in feeding IDL file :"+
			   idlFile+ " : "+ex);
      }

      //now look at attributes
      //traverseExtended("IDL:WebFlow/test:1.0");
      traverse(repository);
      //setInterfaceDesc(null);
    }

public static void waitUntil(String ref)
  {
    boolean flag=true;
    while(flag){
      org.omg.CORBA.Object obj = orb.string_to_object(ref);
      boolean non_exist = true;
      try{
	non_exist = obj._non_existent();
      }catch(org.omg.CORBA.COMM_FAILURE ex){}
      catch(org.omg.CORBA.OBJECT_NOT_EXIST ex){}
      
      if (!non_exist)
	flag = false;
      try{
	Thread.sleep(500);
      }catch(InterruptedException ex){   }
    }
  }


public static org.omg.CORBA.Object startIntRep()
  {
	String ref=null ;
	printProcessOut ppo;
	org.omg.CORBA.Object IRobj=null;

	System.out.println("start interface Repository");
	String command = "irserv --ior";
	try{
	 Process p = Runtime.getRuntime().exec(command);
	 ppo = new printProcessOut(p);
     
	 ref = ppo.getIOROfProcess();
	 System.out.println("WebFlow server got IOR of IR:"+ref);
	 ppo.startProcess(); 
	}catch (Exception ex){
		 System.out.println("Error in starting ModuleFactory in Proxy:"+ex);
	}

	IRobj = orb.string_to_object(ref);
	System.out.println("WebFlow server connected to IR:"+IRobj);
	((com.ooc.CORBA.ORB)orb).add_initial_reference("InterfaceRepository", IRobj);
	System.out.println("WebFlow server connected to IR");
	return IRobj;
 }	

 public static void setInterfaceDesc(InterfaceDef nextDef )

  {
    InterfaceDef idef=null;
    FullInterfaceDescription  fullInterfaceDesc=null;

    System.out.println ("Begin :"+nextDef);
    if (nextDef == null){
      String  []idls = null;//attrInfo._userModuleImplBase._ob_ids_;
      //String  []idls = attrInfo._myattImplBase._ob_ids_;
      org.omg.CORBA.Contained contained = repository.lookup_id(idls[0]);	
      idef = org.omg.CORBA.InterfaceDefHelper.narrow(contained);
       System.out.println ("setInterfaceDesc:idsl:"+idls[0]+" idef:"+idef+
			    " conained:"+contained);
    }
    else
      idef = nextDef;
    
    
    fullInterfaceDesc = idef.describe_interface();  
    System.out.println ("interface name:"+fullInterfaceDesc.name);
    System.out.println ("interface id:"+fullInterfaceDesc.id);

    OperationDescription []ods = fullInterfaceDesc.operations;
    for(int k=0;k<ods.length;k++){ 
      OperationDescription kops = ods[k];
      System.out.println("go method:"+kops.name);
      interfacedef.put(kops.name,kops);
    }   
    try{
      AttributeDescription []atts = fullInterfaceDesc.attributes;
      for(int k=0;k<atts.length;k++){ 
	AttributeDescription att = atts[k];
	System.out.println("name of Attribute:"+att.name);
	System.out.println("Rep id of Attribute:"+att.id);
	System.out.println("Attribute defined in :"+att.defined_in);
	System.out.println("Kind value:"+att.type.kind().value());
	System.out.println("type of Attribute:type_id"+att.type.id()+
			 " type_name:"+att.type.name());
	System.out.println("mode of Attribute:"+att.mode);
    
	//extract the usage name of attribute from att.type.id()
	InterfaceDef att_idef=null;
	org.omg.CORBA.Contained contained=repository.lookup_id(att.type.id());
	att_idef = org.omg.CORBA.InterfaceDefHelper.narrow(contained);
	String baseID = baseInterface(att_idef);
	if (baseID.indexOf("vetoableProperty") >=0)
	  System.out.println("Thi is vetoableProperty ");
	else if (baseID.indexOf("property")>=0)
	  System.out.println("Thi is simple property ");
	else if (baseID.indexOf("genericEvent")>=0)
	  System.out.println("Thi is genericEvent ");

	//first get tha name of usage name
	//find Container
	contained = att_idef.lookup("eventName");
	ConstantDef cdef=org.omg.CORBA.ConstantDefHelper.narrow(contained);
	Description adesc = cdef.describe();
        Any aval = adesc.value;
	ConstantDescription cons_desc=ConstantDescriptionHelper.extract(aval);
	String name = cons_desc.value.extract_string();
	System.out.println("The usage name of attribute :"+name);
	
      }
    }catch(org.omg.CORBA.TypeCodePackage.BadKind ex){
    System.out.println("Exc:"+ex);};

    InterfaceDef []idefs = idef.base_interfaces();
    for (int b=0;b<idefs.length;b++){  
      //setInterfaceDesc(idefs[b]);
    }  
  }

  public static String baseInterface(InterfaceDef att_idef)
  {
     InterfaceDef []base_idefs = att_idef.base_interfaces();
     InterfaceDef top_idef = base_idefs[0];
     
     FullInterfaceDescription  fullInterfaceDesc=null;
     fullInterfaceDesc = top_idef.describe_interface(); 
     String id = fullInterfaceDesc.id;
     return id ;
     

}
/*
 public static boolean whichAttribute(InterfaceDef att_idef, String baseID)
  {

    InterfaceDef []base_idefs = att_idef.base_interfaces();
    for(int k=0;k<base_idefs.length;k++){
      InterfaceDef next_idef = base_idefs[k];
      fullInterfaceDesc = next_idef.describe_interface();
      String next_id = fullInterfaceDesc.id;
      if (next_id.indexOf(baseID) >= 0)
	return true;
    }
    return false;
  }


  public static String extractAttsEvents(Contained achild)
  {
    InterfaceDef att_idef=null;
    org.omg.CORBA.Contained contained;

    InterfaceDef idef=org.omg.CORBA.InterfaceDefHelper.narrow(achild);
    FullInterfaceDescription fullIntDesc = idef.describe_interface();  
    AttributeDescription []atts = fullIntDesc.attributes;
    for(int k=0;k<atts.length;k++){ 
	AttributeDescription att = atts[k];
	//extract the usage name of attribute from att.type.id()
	contained = repository.lookup_id(att.type.id());
	att_idef  = org.omg.CORBA.InterfaceDefHelper.narrow(contained);
	String baseID = baseInterface(att_idef);
	if (whichAttribute("vetoableProperty"))
	  System.out.println("Thi is vetoableProperty ");
	else if (whichAttribute("property"))
	  System.out.println("Thi is simple property ");
	else if (whichAttribute("genericEvent"))
	  System.out.println("Thi is genericEvent ");

	//first get tha name of usage name
	//find Container
	contained = att_idef.lookup("eventName");
	ConstantDef cdef=org.omg.CORBA.ConstantDefHelper.narrow(contained);
	Description adesc = cdef.describe();
        Any aval = adesc.value;
	ConstantDescription cons_desc=ConstantDescriptionHelper.extract(aval);
	String name = cons_desc.value.extract_string();
	System.out.println("The usage name of attribute :"+name);
	
      }
    }catch(org.omg.CORBA.TypeCodePackage.BadKind ex){};

  }
  
  public static String 
  */

  public static boolean isUserModule(Contained achild)
  {
    FullInterfaceDescription  fullInterfaceDesc,my_idefDesc;

    int desc_val = childKind(achild);
    if (desc_val != org.omg.CORBA.DefinitionKind._dk_Interface)
      return false;
    
    InterfaceDef att_idef=org.omg.CORBA.InterfaceDefHelper.narrow(achild);
    my_idefDesc = att_idef.describe_interface();
    String my_id =  my_idefDesc.id;

    //BeanContext and WebFlowContext inherit BeanContextChild...
    if ((my_id.indexOf("BeanContext") >=0)||
	(my_id.indexOf("WebFlowContext") >=0))
      return false;

    InterfaceDef []base_idefs = att_idef.base_interfaces();
    for(int k=0;k<base_idefs.length;k++){
      InterfaceDef next_idef = base_idefs[k];
      fullInterfaceDesc = next_idef.describe_interface();
      String next_id = fullInterfaceDesc.id;
      if (next_id.indexOf("BeanContextChild") >= 0)
	return true;
    }
    return false;

  }

public static int  childKind(Contained achild)
  {
    org.omg.CORBA.ContainedPackage.Description desc = achild.describe();
    org.omg.CORBA.DefinitionKind kind = desc.kind;
    int desc_val = kind.value();
    return desc_val;
  }

 public static boolean isContainer(Contained achild)
  {
    int desc_val = childKind(achild);
    if (desc_val == org.omg.CORBA.DefinitionKind._dk_Module)
      return true;
    else
      return false;
  }


 public static void traverse(Container container)
  {
    String repID,name;
    System.out.println("traverse:recurse..");
    Contained []childs =  container.contents(
				      org.omg.CORBA.DefinitionKind.dk_all,
				      false);
    for(int k=0;k<childs.length;k++){
      Contained achild = childs[k];
      repID = achild.id();
      name  = achild.name();
      System.out.println(" name:"+name+ " repID:"+repID);
      if (isUserModule(achild) ){
	System.out.println("I Got UserModule ...");
	setInterfaceDesc(org.omg.CORBA.InterfaceDefHelper.narrow(achild));
      }
      //if this child is a container traverse its children recursively
      if (isContainer(achild))
	traverse(ContainerHelper.narrow(achild));
    }
  }

}

