package attrInfo;
import WebFlow.*;
import WebFlow.event.*;
import org.omg.CORBA.*;
import java.io.*;
import java.util.*;
import org.omg.CORBA.InterfaceDefPackage.*;
import org.omg.CORBA.ContainedPackage.*;
   
public class extractAttEvt{
   static ORB orb ;
   static Hashtable interfacedef;
   static  org.omg.CORBA.Repository repository ;


   public static void main(String args[])
    {
      org.omg.CORBA.Object IRobj=null;
      String idlFile = args[0];
      String IRstr   ; //= args[1];
      System.out.println("I am looking for idl file:"+idlFile);
      orb = ORB.init(args, new java.util.Properties());
      BOA boa = orb.BOA_init(args, new java.util.Properties());
      interfacedef = new Hashtable();

     
      IRobj = startIntRep();
      repository = org.omg.CORBA.RepositoryHelper.narrow(IRobj);
     
      //first irfeed the idlFile
      IRstr = orb.object_to_string(IRobj);
      if (IRstr == null){
	System.out.println("I am returning because IT is null");
	return;
      }

      //wait until IR is up
      waitUntil(IRstr);
      
      
      String command = "irfeed -ORBrepository "+ IRstr+" "+idlFile;
      try{
	System.out.println("configReader :irfeeding the file:"+idlFile);
	Process p = Runtime.getRuntime().exec(command);

	p.waitFor();
      }catch (Exception ex){
	System.out.println("Error in feeding IDL file :"+
			   idlFile+ " : "+ex);
      }

      //now look at attributes
      
      setInterfaceDesc(null);
    }

public static void waitUntil(String ref)
  {
    boolean flag=true;
    while(flag){
      org.omg.CORBA.Object obj = orb.string_to_object(ref);
      boolean non_exist = true;
      try{
	non_exist = obj._non_existent();
      }catch(org.omg.CORBA.COMM_FAILURE ex){}
      catch(org.omg.CORBA.OBJECT_NOT_EXIST ex){}
      
      if (!non_exist)
	flag = false;
      try{
	Thread.sleep(500);
      }catch(InterruptedException ex){   }
    }
  }


public static org.omg.CORBA.Object startIntRep()
  {
	String ref=null ;
	printProcessOut ppo;
	org.omg.CORBA.Object IRobj=null;

	System.out.println("start interface Repository");
	String command = "irserv --ior";
	try{
	 Process p = Runtime.getRuntime().exec(command);
	 ppo = new printProcessOut(p);
     
	 ref = ppo.getIOROfProcess();
	 System.out.println("WebFlow server got IOR of IR:"+ref);
	 ppo.startProcess(); 
	}catch (Exception ex){
		 System.out.println("Error in starting ModuleFactory in Proxy:"+ex);
	}

	IRobj = orb.string_to_object(ref);
	System.out.println("WebFlow server connected to IR:"+IRobj);
	((com.ooc.CORBA.ORB)orb).add_initial_reference("InterfaceRepository", IRobj);
	System.out.println("WebFlow server connected to IR");
	return IRobj;
 }	

 public static void setInterfaceDesc(InterfaceDef nextDef )

  {
    InterfaceDef idef=null;
    FullInterfaceDescription  fullInterfaceDesc=null;

    System.out.println ("Begin :"+nextDef);
    if (nextDef == null){
      String  []idls = attrInfo._userModuleImplBase._ob_ids_;
      //String  []idls = attrInfo._myattImplBase._ob_ids_;
      org.omg.CORBA.Contained contained = repository.lookup_id(idls[0]);	
      idef = org.omg.CORBA.InterfaceDefHelper.narrow(contained);
       System.out.println ("setInterfaceDesc:idsl:"+idls[0]+" idef:"+idef+
			    " conained:"+contained);
    }
    else
      idef = nextDef;
    
    
    fullInterfaceDesc = idef.describe_interface();  
    System.out.println ("interface name:"+fullInterfaceDesc.name);
    System.out.println ("interface id:"+fullInterfaceDesc.id);

    OperationDescription []ods = fullInterfaceDesc.operations;
    for(int k=0;k<ods.length;k++){ 
      OperationDescription kops = ods[k];
      System.out.println("go method:"+kops.name);
      interfacedef.put(kops.name,kops);
    }   
    try{
      AttributeDescription []atts = fullInterfaceDesc.attributes;
      for(int k=0;k<atts.length;k++){ 
	AttributeDescription att = atts[k];
	System.out.println("name of Attribute:"+att.name);
	System.out.println("Rep id of Attribute:"+att.id);
	System.out.println("Attribute defined in :"+att.defined_in);
	System.out.println("type of Attribute:type_id"+att.type.id()+
			 " type_name:"+att.type.name());
	System.out.println("mode of Attribute:"+att.mode);
    
	//extract the usage name of attribute from att.type.id()
	InterfaceDef att_idef=null;
	org.omg.CORBA.Contained contained=repository.lookup_id(att.type.id());
	att_idef = org.omg.CORBA.InterfaceDefHelper.narrow(contained);
	String baseID = baseInterface(att_idef);
	if (baseID.indexOf("vetoableProperty") >=0)
	  System.out.println("Thi is vetoableProperty ");
	else if (baseID.indexOf("property")>=0)
	  System.out.println("Thi is simple property ");
	else if (baseID.indexOf("genericEvent")>=0)
	  System.out.println("Thi is genericEvent ");

	//first get tha name of usage name
	//find Container
	contained = att_idef.lookup("eventName");
	ConstantDef cdef=org.omg.CORBA.ConstantDefHelper.narrow(contained);
	Description adesc = cdef.describe();
        Any aval = adesc.value;
	ConstantDescription cons_desc=ConstantDescriptionHelper.extract(aval);
	String name = cons_desc.value.extract_string();
	System.out.println("The usage name of attribute :"+name);
	
      }
    }catch(org.omg.CORBA.TypeCodePackage.BadKind ex){};

    InterfaceDef []idefs = idef.base_interfaces();
    for (int b=0;b<idefs.length;b++){  
      setInterfaceDesc(idefs[b]);
    }  
  }

  public static String baseInterface(InterfaceDef att_idef)
  {
     InterfaceDef []base_idefs = att_idef.base_interfaces();
     InterfaceDef top_idef = base_idefs[0];
     
     FullInterfaceDescription  fullInterfaceDesc=null;
     fullInterfaceDesc = top_idef.describe_interface(); 
     String id = fullInterfaceDesc.id;
     return id ;
  }

}

